searchData={"items":[{"type":"module","title":"DNSSRVCluster","doc":"App functions","ref":"DNSSRVCluster.html"},{"type":"function","title":"DNSSRVCluster.get_pid/0","doc":"Get pid of application worker.","ref":"DNSSRVCluster.html#get_pid/0"},{"type":"function","title":"DNSSRVCluster.list_all_nodes/1","doc":"Get list of all nodes that exist in DNS SRV record.","ref":"DNSSRVCluster.html#list_all_nodes/1"},{"type":"function","title":"DNSSRVCluster.list_connected_nodes/1","doc":"Get list of connected nodes.","ref":"DNSSRVCluster.html#list_connected_nodes/1"},{"type":"function","title":"DNSSRVCluster.list_unconnected_nodes/1","doc":"Get list of nodes that are not connected.","ref":"DNSSRVCluster.html#list_unconnected_nodes/1"},{"type":"module","title":"DNSSRVCluster.Worker","doc":"Main app worker\n\nYou can use it in your own supervision tree if you want.","ref":"DNSSRVCluster.Worker.html"},{"type":"function","title":"DNSSRVCluster.Worker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DNSSRVCluster.Worker.html#child_spec/1"},{"type":"function","title":"DNSSRVCluster.Worker.warn_node_out_of_release_running_without_longnames/0","doc":"","ref":"DNSSRVCluster.Worker.html#warn_node_out_of_release_running_without_longnames/0"},{"type":"extras","title":"DNSSRVCluster","doc":"# DNSSRVCluster\n\nElixir clustering with DNS SRV records.\n\n---\n\n[![CI](https://github.com/pertsevds/dns_srv_cluster/actions/workflows/ci.yml/badge.svg)](https://github.com/pertsevds/dns_srv_cluster/actions/workflows/ci.yml)\n[![Coverage Status](https://coveralls.io/repos/github/pertsevds/dns_srv_cluster/badge.svg?branch=main)](https://coveralls.io/github/pertsevds/dns_srv_cluster?branch=main)","ref":"readme.html"},{"type":"extras","title":"Installation - DNSSRVCluster","doc":"The package can be installed by adding `dns_srv_cluster` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dns_srv_cluster, \"~> 0.2.0\"}\n  ]\nend\n```\n\nAdd to your DNS zone your SRV record (https://en.wikipedia.org/wiki/SRV_record):\n\n```sh\n_app._tcp.yourdomain.com. 60 IN SRV 0 10 1234 node1.yourdomain.com.\n_app._tcp.yourdomain.com. 60 IN SRV 0 10 1234 node2.yourdomain.com.\n_app._tcp.yourdomain.com. 60 IN SRV 0 10 1234 node3.yourdomain.com.\n_app._tcp.yourdomain.com. 60 IN SRV 0 10 1234 node4.yourdomain.com.\n```\n\nAdd to your config files (`config/prod.exs`, `config/dev.exs`):\n\n```elixir\nconfig :dns_srv_cluster,\n  query: \"_app._tcp.yourdomain.com\"\n```\n\nAdd this to your `rel/env.sh.eex`:\n\n```sh\nexport RELEASE_DISTRIBUTION=\"${RELEASE_DISTRIBUTION:-\"name\"}\"\nexport RELEASE_NODE=\"${RELEASE_NODE:-\"<%= @release.name %>\"}\"\n```\n\nBy default, nodes from the same release will have the same cookie. If you want different\napplications or releases to connect to each other, then you must set the `RELEASE_COOKIE`,\neither in your deployment platform or inside `rel/env.sh.eex`:\n\n```sh\nexport RELEASE_COOKIE=\"my-app-cookie\"\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration options - DNSSRVCluster","doc":"* `query` - your DNS SRV record, for example: \"_app._tcp.yourdomain.com\".\n  * `interval` - the millisec interval between DNS queries. Defaults to `5_000`.\n  * `connect_timeout` - the millisec timeout to allow discovered nodes to connect. Defaults to `10_000`.","ref":"readme.html#configuration-options"},{"type":"extras","title":"If you want it in your supervision tree - DNSSRVCluster","doc":"Do in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dns_srv_cluster, \"~> 0.2.0\", runtime: false}\n  ]\nend\n```\n\n`runtime: false` will block application from starting.\n\nAnd use `DNSSRVCluster.Worker` as a child:\n\n```elixir\nchildren = [\n  {DNSSRVCluster.Worker, query: \"_app._tcp.yourdomain.com\"}\n]\n\n{:ok, pid} = Supervisor.start_link(children, strategy: :one_for_one)\n```","ref":"readme.html#if-you-want-it-in-your-supervision-tree"},{"type":"extras","title":"Support Matrix - DNSSRVCluster","doc":"Tests automatically run against a matrix of OTP and Elixir Versions, see the [ci.yml](https://github.com/pertsevds/dns_srv_cluster/tree/main/.github/workflows/ci.yml) for details.\n\n| OTP \\ Elixir | 1.12 | 1.13 | 1.14 | 1.15 | 1.16 |\n|:------------:|:----:|:----:|:----:|:----:|:----:|\n| 24           | ✅   | ✅   | ✅   | ✅   | ✅  |\n| 25           | N/A  | ✅   | ✅   | ✅   | ✅   |\n| 26           | N/A  | N/A  | ✅   | ✅   | ✅   |","ref":"readme.html#support-matrix"},{"type":"extras","title":"Documentation - DNSSRVCluster","doc":"Documentation can be found at  .","ref":"readme.html#documentation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}